/*
 * indentation.cuh
 *
 *  Created on: Apr 9, 2010
 *      Author: zhmurov
 */

#ifndef INDENTATION_CUH_
#define INDENTATION_CUH_

#define INDENTATION_ON_STRING				"indentation"

#define INDENTATION_CHIP_POSITION_STRING	"indentationChip"
#define INDENTATION_TIP_POSITION_STRING		"indentationTip"
#define INDENTATION_DIRECTION_STRING		"indentationDirection"
#define INDENTATION_SURFACE_R0_STRING		"indentationSurfaceR0"
#define INDENTATION_SURFACE_N_STRING		"indentationSurfaceN"
#define INDENTATION_TIP_RADIUS_STRING		"indentationTipR"
#define INDENTATION_KS_STRING				"indentationKs"
#define INDENTATION_DELTAX_STRING			"indentationDeltaX"
#define INDENTATION_MOVE_SURFACE			"indentationMoveSurface"
#define INDENTATION_SIGMA_STRING			"indentationSigma"
#define INDENTATION_EL_STRING				"indentationEl"
#define INDENTATION_TIP_ZETA_STRING			"indentationTipZeta"
#define INDENTATION_OUTPUT_FILENAME_STRING	"indentationOutput"
#define INDENTATION_RETRACTION_STEP_STRING	"indentationRetractionStep"
#define INDENTATION_OUTPUT_FREQ_STRING		"indentationOutputFreq"

#define INDENTATION_SHOW_TIP_SURFACE_STRING "indentationShowTipSurf"
#define INDENTATION_VMD_CONNECT_SCRIPT		"indentationSurfConnectFile"
#define INDENTATION_MICA_SIZE_STRING		"indentationSurfaceSize"
#define INDENTATION_MICA_STEP_STRING		"indentationSurfaceStep"

#define DEFAULT_INDENTATION_FILENAME		"indentation.<name>_<author><run>_<stage>.dat"
#define DEFAULT_INDENTATION_SHOW_TIP_SURFACE 0
#define DEFAULT_INDENTATION_MICA_SIZE		51
#define DEFAULT_INDENTATION_MICA_STEP		10
#define DEFAULT_INDENTATION_OUTPUT_FREQ		1000

struct Indentation {
	float3 tipCoord;
	float3 chipCoord;
	float3 chipCoord0;
	float3 direction;
	float V;
	float dx;
	int moveSurface;
	float tipRadius;
	float cantileverKs;
	float a6;
	float el;
	float tipZeta;
	float3 micaN;
	float3 micaR0;
	float3 micaR;
	float4* h_tipForces;
	float4* d_tipForces;
	float4 tipForce;
	FILE* out;
	long int retractionStep;
	int showTipSurface;
	int surfaceSize;
	float surfaceStep;
	int outputFreq;
	float4 fav;
	float3 tipCoordAv;
	float3 chipCoordAv;
	float kDeltaXAv;
	int micaSize;
};

Indentation indentation;
__device__ __constant__ Indentation c_indentation;
SOPPotential indentationPotential;
SOPUpdater indentationUpdater;
SOPUpdater additionalAminosUpdater;

void createIndentationPotential();
void initIndentation();
inline void computeIndentation();
inline void computeIndentationEnergy();
inline void updateTipPosition();
void updateAdditionalAminos();

#endif /* INDENTATION_CUH_ */
