#include "../gsop.cuh"
/*
 * indentation_kernel.cu
 *
 *  Created on: Apr 9, 2010
 *      Author: zhmurov
 */

__global__ void indentation_kernel(){
	int d_i = blockIdx.x*blockDim.x + threadIdx.x;
	if(d_i < c_gsop.aminoCount){
#ifdef NOTEXTURE
		float4 coord = c_gsop.d_coord[d_i];
#else
		float4 coord = tex1Dfetch(t_coord, d_i);
#endif
		float4 f = c_gsop.d_forces[d_i];
		float4 f_in = c_indentation.d_tipForces[d_i];//make_float4(0.0, 0.0, 0.0, 0.0);
		float4 df;
		float4 dr;
		dr.x = c_indentation.tipCoord.x - coord.x;
		dr.y = c_indentation.tipCoord.y - coord.y;
		dr.z = c_indentation.tipCoord.z - coord.z;
		dr.w = sqrt(dr.x*dr.x+dr.y*dr.y+dr.z*dr.z);
		df.w = dr.w - c_indentation.tipRadius;
		df.w = powf(df.w, 7);
		//if(dr.w < c_pairs.pairsCutoff2){
			df.w = c_indentation.a6/df.w;
			df.w = -6.0*c_indentation.el*df.w/dr.w;
			df.x = dr.x*df.w;
			df.y = dr.y*df.w;
			df.z = dr.z*df.w;
		//}
		f_in.x += df.x;
		f_in.y += df.y;
		f_in.z += df.z;
		c_indentation.d_tipForces[d_i] = f_in;
		dr.x = coord.x - c_indentation.micaR.x;
		dr.y = coord.y - c_indentation.micaR.y;
		dr.z = coord.z - c_indentation.micaR.z;
		dr.w = dr.x*c_indentation.micaN.x + dr.y*c_indentation.micaN.y + dr.z*c_indentation.micaN.z;
		dr.w = powf(dr.w, 8);
		dr.w = 6.0*c_indentation.el*c_indentation.a6/dr.w;
		f.x += c_indentation.micaN.x*dr.w + df.x;
		f.y += c_indentation.micaN.y*dr.w + df.y;
		f.z += c_indentation.micaN.z*dr.w + df.z;
		c_gsop.d_forces[d_i] = f;
	}
}
